/******************************************************************************/
/** @file    plugin.cpp
    @brief mrt plugin ̃vOCS

    @author mfsocket
    @date   2011/06/21
    @version 1.00
*/
/******************************************************************************/
#include "common.h"



std::map<int, exec_command>	g_command;



/*----------------------------------------------------------------------------*/
//  mrtp_startup()
/*----------------------------------------------------------------------------*/
/**
  * @brief plugin ̊Jn
  *
  * @param  method Ăяõ\bhIuWFNg
  *
  * @retval : true  s: false
  */
/*----------------------------------------------------------------------------*/
bool  __cdecl 	mrtp_startup( PluginMethod* method )
{
	int result = method->access_init();
	if( result ){
		method->out( "[^[ANZXɎs܂B" );
		return false;
	}

	// R}h̏
	g_command[COMMAND_UNKNOWN]		  = command_unknown;
	g_command[COMMAND_REBOOT]		  = command_reboot;
	g_command[COMMAND_LINKUP]		  = command_linkup;
	g_command[COMMAND_LINKDOWN]		  = command_linkdown;
	g_command[COMMAND_GETLOG]		  = command_getlog;
	g_command[COMMAND_GETLOG_SYSTEM]  = command_getsyslog;
	g_command[COMMAND_GETIP]		  = command_getip;
	g_command[COMMAND_GETIPS]		  = command_getips;
	g_command[COMMAND_GETALLINFO]	  = command_getall;
	g_command[COMMAND_ENABLE_ECO]	  = command_enable_eco;
	g_command[COMMAND_START_ECO]	  = command_start_eco;
	g_command[COMMAND_DISABLE_ECO]	  = command_disable_eco;
	g_command[COMMAND_ECO]			  = command_eco;


	return true;
}
/*----------------------------------------------------------------------------*/
//  mrtp_main()
/*----------------------------------------------------------------------------*/
/**
  * @brief plugin ̃C
  *
  * @param  method Ăяõ\bhIuWFNg
  * @param  command R}h^Cv
  * @param  command_arg R}h
  *
  * @retval plugin.h  main return value Q
  **/
/*----------------------------------------------------------------------------*/
int   __cdecl 	mrtp_main( PluginMethod* method, int command, const char* command_arg )
{
	return g_command[command]( method, command, command_arg );
}

/*----------------------------------------------------------------------------*/
//  mrtp_cleanup()
/*----------------------------------------------------------------------------*/
/**
  * @brief plugin ̏I
  *
  * @param  method Ăяõ\bhIuWFNg
  */
/*----------------------------------------------------------------------------*/
void  __cdecl 	mrtp_cleanup( PluginMethod* method )
{
}

/*----------------------------------------------------------------------------*/
//  mrtp_plugin_name()
/*----------------------------------------------------------------------------*/
/**
  * @brief vOĈԂ܂B
  *
  * @retval vOC
  */
/*----------------------------------------------------------------------------*/
char* __cdecl		mrtp_plugin_name()
{
	return "WR8700n_router1.0.13 command line manager.";
}

/*----------------------------------------------------------------------------*/
//  mrtp_plugin_author()
/*----------------------------------------------------------------------------*/
/**
  * @brief vOC̒ҖԂ܂B
  *
  * @retval vOC
  */
/*----------------------------------------------------------------------------*/
char* __cdecl		mrtp_plugin_author()
{
	return "mfsocket";
}

/*----------------------------------------------------------------------------*/
//  mrtp_plugin_version()
/*----------------------------------------------------------------------------*/
/**
  * @brief vOC̃o[WԂ܂B
  *
  * @retval vOCo[W
  */
/*----------------------------------------------------------------------------*/
char* __cdecl		mrtp_plugin_version()
{
	return "1.01";
}

/*----------------------------------------------------------------------------*/
//  mrtp_plugin_routername()
/*----------------------------------------------------------------------------*/
/**
  * @brief vOCS郋[^[̐̂Ԃ܂B
  *
  * @retval [^[
  */
/*----------------------------------------------------------------------------*/
char* __cdecl		mrtp_plugin_routername()
{
	return "AtermWR8700n";
}

/*----------------------------------------------------------------------------*/
//  mrtp_plugin_homepage()
/*----------------------------------------------------------------------------*/
/**
  * @brief vOC҂̃z[y[WԂ܂B
  *
  * @retval z[y[WURLB "none" ԂB
  */
/*----------------------------------------------------------------------------*/
char* __cdecl		mrtp_plugin_homepage()
{
	return "http://www13.atpages.jp/mfsocket/web/";
}

/*----------------------------------------------------------------------------*/
//  mrtp_plugin_help()
/*----------------------------------------------------------------------------*/
/**
  * @brief vOC̃wvo͂܂B
  *
  * @param  method Ăяõ\bhIuWFNg
  *
  * @retval wvꍇ true.  false.
  */
/*----------------------------------------------------------------------------*/
bool __cdecl		mrtp_plugin_help( PluginMethod* method )
{
	const char* command_list[] = {
		"reboot",		"",
		"linkup",		"~",
		"linkdown",		"~",
		"getlog",		"",
		"getsyslog",	"",
		"getip",		"",
		"getips",		"~",
		"getallinfo",	"~",
		"enable_eco",	"",
		"start_eco",	"",
		"disable_eco",	"",
		"eco",			"~",
		NULL, NULL,
	};
	int i = 0;
	while( command_list[i] ){
		method->outf( " %12s %s\n", command_list[i], command_list[i+1] );
		i += 2;
	}
	return true;	// help Ă܂B
}

