/******************************************************************************/
/** @file    plugin.h
 *  @brief mrt plugin header
 *
 *  @author: mfsocket
    @date   2011/06/21
 *  @version 1.0.0
 **/
/******************************************************************************/

#ifndef __MRT_PLUGIN_H_INCLUDE__
#define __MRT_PLUGIN_H_INCLUDE__


#include <Windows.h>

// command key
enum{
	COMMAND_UNKNOWN=0,			// `R}hBmethod->commsnd() ĂяoA񂩂߂ĂB
	COMMAND_REBOOT,				// reboot             ċNR}h
	COMMAND_LINKUP,				// linkup			  ڑ
	COMMAND_LINKDOWN,			// linkdown			  ؒf
	COMMAND_GETLOG,				// getlog             O擾
	COMMAND_GETLOG_SYSTEM,		// getsyslog          VXeO擾
	COMMAND_GETIP,				// getip			  WANIP ̎擾
	COMMAND_GETIPS,				// getips			  WANIP SĎ擾
	COMMAND_GETALLINFO,			// getallinfo  or all 擾łRlNV(IP,DNS,MACAhX,etc)SĎ擾
	COMMAND_ENABLE_ECO,			// enable_eco  or ee  GR[hON  ( Lɂ邾ŊJnԂ̓[^[ˑ )
	COMMAND_START_ECO,			// start_eco   or se  GR[hJn( GR[hKJn )
	COMMAND_DISABLE_ECO,		// disable_eco or de  GR[hOFF ( GR[h𖳌ɂ )
	COMMAND_ECO,				// eco                GR[h

	COMMAND_ARRAY_END,			// KŌɒ`L[[h
};

// main return value
enum{
	PLUGIN_SUCCESS=0,	// 
	PLUGIN_ERROR,		// G[
	PLUGIN_SIGNAL,		// VOi
	PLUGIN_UNKNOWN,		// 
};

typedef void	(__cdecl *typedef_sleep)( DWORD millis );
typedef int		(__cdecl *typedef_out)( const char* str );
typedef int		(__cdecl *typedef_outf)( const char* format, ... );
typedef int		(__cdecl *typedef_set_error)( const char* format, ... );
typedef char*	(__cdecl *typedef_commond)();
typedef int		(__cdecl *typedef_access_init)();
typedef char*	(__cdecl *typedef_access_get)( const char* path );
typedef char*	(__cdecl *typedef_access_post)( const char* path, const char* post_data );
typedef char*	(__cdecl *typedef_filter_htmltag)( const char* str, const char* tag );
typedef char*	(__cdecl *typedef_filter_htmlclass)( const char* str, const char* tag_class );
typedef char*	(__cdecl *typedef_pickup_htmlhidden)( const char* str );
typedef char*	(__cdecl *typedef_pickup_htmlsubmit)( const char* str );
typedef char*	(__cdecl *typedef_pickup_htmlinputselect)( const char* str, BOOL bEnableInput );
typedef char*	(__cdecl *typedef_string_concat)( const char* a, const char* b );
typedef char*	(__cdecl *typedef_string_trim)( const char* src );
typedef char*	(__cdecl *typedef_string_setvalue)( const char* src, const char* key, const char* value );
typedef char*	(__cdecl *typedef_string_getvalue)( const char* src, const char* key );
typedef char*	(__cdecl *typedef_string_deletekey)( const char* src, const char* key );
typedef char*	(__cdecl *typedef_string_substr)( const char* src, int s, int e );
typedef char*	(__cdecl *typedef_string_euc2sjis)( const char* src );
typedef char*	(__cdecl *typedef_string_utf82sjis)( const char* src );


typedef struct{
	/**
	* X[vsBlike Windows API 'Sleep()'
	*/
	typedef_sleep					sleep;				// X[v
	/**
	* plugin ʏóBsR[ho͂܂Blike Windows API 'puts()'
	*/
	typedef_out						out;				// ʏo
	/**
	* plugin wtʏóBsR[h͊܂܂܂Blike Windows API 'printf()'
	*/
	typedef_outf					outf;				// ʏo(t)
	/**
	* G[Ƃ plugin bZ[WݒB
	*/
	typedef_set_error				set_error;			// G[Ƃ plugin bZ[W
	/**
	* s command ̕擾Bunknown R}h̎Aplugin ƎɊgsɂg܂B
	*/
	typedef_commond					commond;			// R}h̎擾
	/**
	* [^[ANZX̏Bs 0BsČp邱Ƃ͏o܂B
	*/
	typedef_access_init				access_init;		// [^[ANZX̏Bs 0 
	/**
	* [^[ւ GET ANZXB
	*/
	typedef_access_get				access_get;			// [^[ւ GET  ANZX
	/**
	* [^[ւ POST ANZXB
	*/
	typedef_access_post				access_post;		// [^[ւ POST ANZX
	/**
	* HTML ^Oɂ镶tB^[sB
	*/
	typedef_filter_htmltag			filter_htmltag;		// HTML ^Oɂ镶tB^[
	/**
	* HTML ^ONX(class=)ɂ镶tB^[sB
	*/
	typedef_filter_htmlclass		filter_htmlclass;	// HTML ^ONX(class=)ɂ镶tB^[
	/**
	* HTML ^ONX(id=)ɂ镶tB^[sB
	*/
	typedef_filter_htmlclass		filter_htmlid;		// HTML ^ONX(id=)ɂ镶tB^[
	/**
	* HTML input hidden  '[key]=[value]&' ̌`ŃsbNAbvsB
	*/
	typedef_pickup_htmlhidden		pickup_htmlhidden;	// HTML input hidden  '[key]=[value]&' ̌`ŃsbNAbvs
	/**
	* HTML input submit  '[key]=[value]&' ̌`ŃsbNAbvsB
	*/
	typedef_pickup_htmlsubmit		pickup_htmlsubmit;	// HTML input submit  '[key]=[value]&' ̌`ŃsbNAbvs
	/**
	* HTML input, select  '[key]=[value]&' ̌`ŃsbNAbvsB
	*/
	typedef_pickup_htmlinputselect	pickup_htmlinputselect;	// HTML input, select  '[key]=[value]&' ̌`ŃsbNAbvs
	/**
	* ̘AsԂ܂B
	*/
	typedef_string_concat			string_concat;		// ̘A
	/**
	* ̑ÕS~菜Ԃ܂B
	*/
	typedef_string_trim				string_trim;		// ̑ÕS~菜
	/**
	* '[key]=[value]&' `̕ value lXV܂BVKǉ͏o܂B
	*/
	typedef_string_setvalue			string_setvalue;	// '[key]=[value]&' `̕ value lXV/VKǉ͏oȂ
	/**
	* '[key]=[value]&' `̕񂩂 value l擾܂B
	*/
	typedef_string_getvalue			string_getvalue;	// '[key]=[value]&' `̕񂩂 value l擾
	/**
	* '[key]=[value]&' `̕񂩂 key l폜܂B
	*/
	typedef_string_deletekey		string_deletekey;	// '[key]=[value]&' `̕񂩂 key l폜
	/**
	* 𔲂o܂B
	*/
	typedef_string_substr			string_substr;		// 𔲂o
	/**
	* euc   sjis ɕϊ擾܂B
	*/
	typedef_string_euc2sjis			string_euc2sjis;	// euc   sjis ɕϊ
	/**
	* utf8   sjis ɕϊ擾܂B
	*/
	typedef_string_utf82sjis		string_utf82sjis;	// utf8  sjis ɕϊ
}PluginMethod;


/**
 *  sigint 荞݂ʒmONX
 */
class  __declspec(dllexport) SigintException{
public:
};


/*---------------------------------------------------------------------------------------------------*/
// plugin Ŏׂ֐
/*---------------------------------------------------------------------------------------------------*/
extern "C"{

__declspec(dllexport) bool  __cdecl 	mrtp_startup( PluginMethod* method );
__declspec(dllexport) int   __cdecl 	mrtp_main( PluginMethod* method, int command, const char* command_arg );
__declspec(dllexport) void  __cdecl 	mrtp_cleanup( PluginMethod* method );
__declspec(dllexport) char* __cdecl		mrtp_plugin_name();
__declspec(dllexport) char* __cdecl		mrtp_plugin_author();
__declspec(dllexport) char* __cdecl		mrtp_plugin_version();
__declspec(dllexport) char* __cdecl		mrtp_plugin_routername();
__declspec(dllexport) char* __cdecl		mrtp_plugin_homepage();
__declspec(dllexport) bool __cdecl		mrtp_plugin_help( PluginMethod* method );

}

#endif //  __MRT_PLUGIN_H_INCLUDE__